diff --git a/drivers/net/bonding/eth_bond_8023ad_private.h b/drivers/net/bonding/eth_bond_8023ad_private.h
index ab7d15f81a..29ee8700c3 100644
--- a/drivers/net/bonding/eth_bond_8023ad_private.h
+++ b/drivers/net/bonding/eth_bond_8023ad_private.h
@@ -196,10 +196,13 @@ struct bond_dev_private;
  *
  * Set mode 4 configuration of bonding interface.
  *
- * @pre Bonding interface must be stopped.
+ * @pre
+ *   Bonding interface must be stopped.
  *
- * @param dev Bonding interface
- * @param conf new configuration. If NULL set default configuration.
+ * @param dev
+ *   Bonding interface
+ * @param conf
+ *   new configuration. If NULL set default configuration.
  */
 void
 bond_mode_8023ad_setup(struct rte_eth_dev *dev,
@@ -210,9 +213,11 @@ bond_mode_8023ad_setup(struct rte_eth_dev *dev,
  *
  * Enables 802.1AX mode and all active members on bonding interface.
  *
- * @param dev Bonding interface
+ * @param dev
+ *   Bonding interface
+ *
  * @return
- *  0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 int
 bond_mode_8023ad_enable(struct rte_eth_dev *dev);
@@ -222,7 +227,8 @@ bond_mode_8023ad_enable(struct rte_eth_dev *dev);
  *
  * Disables 802.1AX mode of the bonding interface and members.
  *
- * @param dev Bonding interface
+ * @param dev
+ *   Bonding interface
  * @return
  *   0 on success, negative value otherwise.
  */
@@ -232,7 +238,8 @@ int bond_mode_8023ad_disable(struct rte_eth_dev *dev);
  * @internal
  *
  * Starts 802.3AX state machines management logic.
- * @param dev Bonding interface
+ * @param dev
+ *   Bonding interface
  * @return
  *   0 if machines was started, 1 if machines was already running,
  *   negative value otherwise.
@@ -244,7 +251,8 @@ bond_mode_8023ad_start(struct rte_eth_dev *dev);
  * @internal
  *
  * Stops 802.3AX state machines management logic.
- * @param dev Bonding interface
+ * @param dev
+ *   Bonding interface
  * @return
  *   0 if this call stopped state machines, -ENOENT if alarm was not set.
  */
@@ -255,9 +263,12 @@ bond_mode_8023ad_stop(struct rte_eth_dev *dev);
  * @internal
  *
  * Passes given slow packet to state machines management logic.
- * @param internals Bonding device private data.
- * @param member_id Member port id.
- * @param slot_pkt Slow packet.
+ * @param internals
+ *   Bonding device private data.
+ * @param member_id
+ *   Member port id.
+ * @param slot_pkt
+ *   Slow packet.
  */
 void
 bond_mode_8023ad_handle_slow_pkt(struct bond_dev_private *internals,
@@ -268,11 +279,13 @@ bond_mode_8023ad_handle_slow_pkt(struct bond_dev_private *internals,
  *
  * Appends given member used member
  *
- * @param dev       Bonding interface.
- * @param port_id   Member port ID to be added
+ * @param dev
+ *   Bonding interface.
+ * @param port_id
+ *   Member port ID to be added
  *
  * @return
- *  0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 void
 bond_mode_8023ad_activate_member(struct rte_eth_dev *dev, uint16_t port_id);
@@ -282,18 +295,21 @@ bond_mode_8023ad_activate_member(struct rte_eth_dev *dev, uint16_t port_id);
  *
  * Denitializes and removes given member from 802.1AX mode.
  *
- * @param dev       Bonding interface.
- * @param member_num Position of member in active_members array
+ * @param dev
+ *   Bonding interface.
+ * @param member_num
+ *   Position of member in active_members array
  *
  * @return
- *  0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 int
 bond_mode_8023ad_deactivate_member(struct rte_eth_dev *dev, uint16_t member_pos);
 
 /**
  * Updates state when MAC was changed on bonding device or one of its members.
- * @param bond_dev Bonding device
+ * @param bond_dev
+ *   Bonding device
  */
 void
 bond_mode_8023ad_mac_address_update(struct rte_eth_dev *bond_dev);
diff --git a/drivers/net/bonding/rte_eth_bond.h b/drivers/net/bonding/rte_eth_bond.h
index 6be5e46deb..28aa341d2f 100644
--- a/drivers/net/bonding/rte_eth_bond.h
+++ b/drivers/net/bonding/rte_eth_bond.h
@@ -95,12 +95,15 @@ extern "C" {
 /**
  * Create a bonding rte_eth_dev device
  *
- * @param name			Name of new link bonding device.
- * @param mode			Mode to initialize bonding device in.
- * @param socket_id		Socket Id on which to allocate eth_dev resources.
+ * @param name
+ *   Name of new link bonding device.
+ * @param mode
+ *   Mode to initialize bonding device in.
+ * @param socket_id
+ *   Socket Id on which to allocate eth_dev resources.
  *
  * @return
- *	Port Id of created rte_eth_dev on success, negative value otherwise
+ *   Port Id of created rte_eth_dev on success, negative value otherwise
  */
 int
 rte_eth_bond_create(const char *name, uint8_t mode, uint8_t socket_id);
@@ -108,10 +111,11 @@ rte_eth_bond_create(const char *name, uint8_t mode, uint8_t socket_id);
 /**
  * Free a bonding rte_eth_dev device
  *
- * @param name			Name of the link bonding device.
+ * @param name
+ *   Name of the link bonding device.
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 int
 rte_eth_bond_free(const char *name);
@@ -119,11 +123,13 @@ rte_eth_bond_free(const char *name);
 /**
  * Add a rte_eth_dev device as a member to the bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param member_port_id		Port ID of member device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param member_port_id
+ *   Port ID of member device.
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 __rte_experimental
 int
@@ -132,11 +138,13 @@ rte_eth_bond_member_add(uint16_t bonding_port_id, uint16_t member_port_id);
 /**
  * Remove a member rte_eth_dev device from the bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param member_port_id		Port ID of member device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param member_port_id
+ *   Port ID of member device.
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 __rte_experimental
 int
@@ -145,11 +153,13 @@ rte_eth_bond_member_remove(uint16_t bonding_port_id, uint16_t member_port_id);
 /**
  * Set link bonding mode of bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param mode				Bonding mode to set
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param mode
+ *   Bonding mode to set
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 int
 rte_eth_bond_mode_set(uint16_t bonding_port_id, uint8_t mode);
@@ -157,10 +167,11 @@ rte_eth_bond_mode_set(uint16_t bonding_port_id, uint8_t mode);
 /**
  * Get link bonding mode of bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *	link bonding mode on success, negative value otherwise
+ *   link bonding mode on success, negative value otherwise
  */
 int
 rte_eth_bond_mode_get(uint16_t bonding_port_id);
@@ -168,11 +179,13 @@ rte_eth_bond_mode_get(uint16_t bonding_port_id);
 /**
  * Set member rte_eth_dev as primary member of bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param member_port_id		Port ID of member device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param member_port_id
+ *   Port ID of member device.
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 int
 rte_eth_bond_primary_set(uint16_t bonding_port_id, uint16_t member_port_id);
@@ -180,10 +193,11 @@ rte_eth_bond_primary_set(uint16_t bonding_port_id, uint16_t member_port_id);
 /**
  * Get primary member of bonding device
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *	Port Id of primary member on success, -1 on failure
+ *   Port Id of primary member on success, -1 on failure
  */
 int
 rte_eth_bond_primary_get(uint16_t bonding_port_id);
@@ -191,13 +205,16 @@ rte_eth_bond_primary_get(uint16_t bonding_port_id);
 /**
  * Populate an array with list of the members port id's of the bonding device
  *
- * @param bonding_port_id	Port ID of bonding eth_dev to interrogate
- * @param members			Array to be populated with the current active members
- * @param len				Length of members array
+ * @param bonding_port_id
+ *   Port ID of bonding eth_dev to interrogate
+ * @param members
+ *   Array to be populated with the current active members
+ * @param len
+ *   Length of members array
  *
  * @return
- *	Number of members associated with bonding device on success,
- *	negative value otherwise
+ *   Number of members associated with bonding device on success,
+ *   negative value otherwise
  */
 __rte_experimental
 int
@@ -208,13 +225,16 @@ rte_eth_bond_members_get(uint16_t bonding_port_id, uint16_t members[],
  * Populate an array with list of the active members port id's of the bonding
  * device.
  *
- * @param bonding_port_id	Port ID of bonding eth_dev to interrogate
- * @param members			Array to be populated with the current active members
- * @param len				Length of members array
+ * @param bonding_port_id
+ *   Port ID of bonding eth_dev to interrogate
+ * @param members
+ *   Array to be populated with the current active members
+ * @param len
+ *   Length of members array
  *
  * @return
- *	Number of active members associated with bonding device on success,
- *	negative value otherwise
+ *   Number of active members associated with bonding device on success,
+ *   negative value otherwise
  */
 __rte_experimental
 int
@@ -224,12 +244,13 @@ rte_eth_bond_active_members_get(uint16_t bonding_port_id, uint16_t members[],
 /**
  * Set explicit MAC address to use on bonding device and it's members.
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param mac_addr			MAC Address to use on bonding device overriding
- *							members MAC addresses
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param mac_addr
+ *   MAC Address to use on bonding device overriding members MAC addresses
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 int
 rte_eth_bond_mac_address_set(uint16_t bonding_port_id,
@@ -239,10 +260,11 @@ rte_eth_bond_mac_address_set(uint16_t bonding_port_id,
  * Reset bonding device to use MAC from primary member on bonding device and it's
  * members.
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *	0 on success, negative value otherwise
+ *   0 on success, negative value otherwise
  */
 int
 rte_eth_bond_mac_address_reset(uint16_t bonding_port_id);
@@ -252,11 +274,13 @@ rte_eth_bond_mac_address_reset(uint16_t bonding_port_id);
  * balance mode, this parameter is otherwise ignored in other modes of
  * operation.
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param policy			Balance mode transmission policy.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param policy
+ *   Balance mode transmission policy.
  *
  * @return
- *	0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 int
 rte_eth_bond_xmit_policy_set(uint16_t bonding_port_id, uint8_t policy);
@@ -264,10 +288,11 @@ rte_eth_bond_xmit_policy_set(uint16_t bonding_port_id, uint8_t policy);
 /**
  * Get the transmit policy set on bonding device for balance mode operation
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *	Balance transmit policy on success, negative value otherwise.
+ *   Balance transmit policy on success, negative value otherwise.
  */
 int
 rte_eth_bond_xmit_policy_get(uint16_t bonding_port_id);
@@ -276,11 +301,13 @@ rte_eth_bond_xmit_policy_get(uint16_t bonding_port_id);
  * Set the link monitoring frequency (in ms) for monitoring the link status of
  * member devices
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param internal_ms		Monitoring interval in milliseconds
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param internal_ms
+ *   Monitoring interval in milliseconds
  *
  * @return
- *	0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 
 int
@@ -290,10 +317,11 @@ rte_eth_bond_link_monitoring_set(uint16_t bonding_port_id, uint32_t internal_ms)
  * Get the current link monitoring frequency (in ms) for monitoring of the link
  * status of member devices
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *	Monitoring interval on success, negative value otherwise.
+ *   Monitoring interval on success, negative value otherwise.
  */
 int
 rte_eth_bond_link_monitoring_get(uint16_t bonding_port_id);
@@ -303,11 +331,13 @@ rte_eth_bond_link_monitoring_get(uint16_t bonding_port_id);
  * Set the period in milliseconds for delaying the disabling of a bonding link
  * when the link down status has been detected
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param delay_ms			Delay period in milliseconds.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param delay_ms
+ *   Delay period in milliseconds.
  *
  * @return
- *  0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 int
 rte_eth_bond_link_down_prop_delay_set(uint16_t bonding_port_id,
@@ -317,10 +347,11 @@ rte_eth_bond_link_down_prop_delay_set(uint16_t bonding_port_id,
  * Get the period in milliseconds set for delaying the disabling of a bonding
  * link when the link down status has been detected
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *  Delay period on success, negative value otherwise.
+ *   Delay period on success, negative value otherwise.
  */
 int
 rte_eth_bond_link_down_prop_delay_get(uint16_t bonding_port_id);
@@ -329,11 +360,13 @@ rte_eth_bond_link_down_prop_delay_get(uint16_t bonding_port_id);
  * Set the period in milliseconds for delaying the enabling of a bonding link
  * when the link up status has been detected
  *
- * @param bonding_port_id	Port ID of bonding device.
- * @param delay_ms			Delay period in milliseconds.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
+ * @param delay_ms
+ *   Delay period in milliseconds.
  *
  * @return
- *  0 on success, negative value otherwise.
+ *   0 on success, negative value otherwise.
  */
 int
 rte_eth_bond_link_up_prop_delay_set(uint16_t bonding_port_id,
@@ -343,10 +376,11 @@ rte_eth_bond_link_up_prop_delay_set(uint16_t bonding_port_id,
  * Get the period in milliseconds set for delaying the enabling of a bonding
  * link when the link up status has been detected
  *
- * @param bonding_port_id	Port ID of bonding device.
+ * @param bonding_port_id
+ *   Port ID of bonding device.
  *
  * @return
- *  Delay period on success, negative value otherwise.
+ *   Delay period on success, negative value otherwise.
  */
 int
 rte_eth_bond_link_up_prop_delay_get(uint16_t bonding_port_id);
diff --git a/drivers/net/bonding/rte_eth_bond_8023ad.h b/drivers/net/bonding/rte_eth_bond_8023ad.h
index 4c280c7565..4936d7fc0c 100644
--- a/drivers/net/bonding/rte_eth_bond_8023ad.h
+++ b/drivers/net/bonding/rte_eth_bond_8023ad.h
@@ -155,8 +155,10 @@ struct rte_eth_bond_8023ad_member_info {
  *
  * Function returns current configuration of 802.3AX mode.
  *
- * @param port_id   Bonding device id
- * @param conf		Pointer to timeout structure.
+ * @param port_id
+ *   Bonding device id
+ * @param conf
+ *   Pointer to timeout structure.
  *
  * @return
  *   0 - if ok
@@ -171,8 +173,10 @@ rte_eth_bond_8023ad_conf_get(uint16_t port_id,
  *
  * Function set new configuration of 802.3AX mode.
  *
- * @param port_id   Bonding device id
- * @param conf		Configuration, if NULL set default configuration.
+ * @param port_id
+ *   Bonding device id
+ * @param conf
+ *   Configuration, if NULL set default configuration.
  * @return
  *   0 - if ok
  *   -EINVAL if configuration is invalid.
@@ -186,8 +190,10 @@ rte_eth_bond_8023ad_setup(uint16_t port_id,
  *
  * Function returns current state of given member device.
  *
- * @param member_id  Port id of valid member.
- * @param conf		buffer for configuration
+ * @param member_id
+ *   Port id of valid member.
+ * @param conf
+ *   buffer for configuration
  * @return
  *   0 - if ok
  *   -EINVAL if conf is NULL or member id is invalid (not a member of given
@@ -201,9 +207,12 @@ rte_eth_bond_8023ad_member_info(uint16_t port_id, uint16_t member_id,
 /**
  * Configure a member port to start collecting.
  *
- * @param port_id	Bonding device id
- * @param member_id	Port id of valid member.
- * @param enabled	Non-zero when collection enabled.
+ * @param port_id
+ *   Bonding device id
+ * @param member_id
+ *   Port id of valid member.
+ * @param enabled
+ *   Non-zero when collection enabled.
  * @return
  *   0 - if ok
  *   -EINVAL if member is not valid.
@@ -215,8 +224,10 @@ rte_eth_bond_8023ad_ext_collect(uint16_t port_id, uint16_t member_id,
 /**
  * Get COLLECTING flag from member port actor state.
  *
- * @param port_id	Bonding device id
- * @param member_id	Port id of valid member.
+ * @param port_id
+ *   Bonding device id
+ * @param member_id
+ *   Port id of valid member.
  * @return
  *   0 - if not set
  *   1 - if set
@@ -228,9 +239,12 @@ rte_eth_bond_8023ad_ext_collect_get(uint16_t port_id, uint16_t member_id);
 /**
  * Configure a member port to start distributing.
  *
- * @param port_id	Bonding device id
- * @param member_id	Port id of valid member.
- * @param enabled	Non-zero when distribution enabled.
+ * @param port_id
+ *   Bonding device id
+ * @param member_id
+ *   Port id of valid member.
+ * @param enabled
+ *   Non-zero when distribution enabled.
  * @return
  *   0 - if ok
  *   -EINVAL if member is not valid.
@@ -242,8 +256,10 @@ rte_eth_bond_8023ad_ext_distrib(uint16_t port_id, uint16_t member_id,
 /**
  * Get DISTRIBUTING flag from member port actor state.
  *
- * @param port_id	Bonding device id
- * @param member_id	Port id of valid member.
+ * @param port_id
+ *   Bonding device id
+ * @param member_id
+ *   Port id of valid member.
  * @return
  *   0 - if not set
  *   1 - if set
@@ -256,9 +272,12 @@ rte_eth_bond_8023ad_ext_distrib_get(uint16_t port_id, uint16_t member_id);
  * LACPDU transmit path for external 802.3ad state machine.  Caller retains
  * ownership of the packet on failure.
  *
- * @param port_id	Bonding device id
- * @param member_id	Port ID of valid member device.
- * @param lacp_pkt	mbuf containing LACPDU.
+ * @param port_id
+ *   Bonding device id
+ * @param member_id
+ *   Port ID of valid member device.
+ * @param lacp_pkt
+ *   mbuf containing LACPDU.
  *
  * @return
  *   0 on success, negative value otherwise.
@@ -284,7 +303,8 @@ rte_eth_bond_8023ad_ext_slowtx(uint16_t port_id, uint16_t member_id,
  *
  * Bonding port must be stopped to change this configuration.
  *
- * @param port_id      Bonding device id
+ * @param port_id
+ *   Bonding device id
  *
  * @return
  *   0 on success, negative value otherwise.
@@ -299,9 +319,11 @@ rte_eth_bond_8023ad_dedicated_queues_enable(uint16_t port_id);
  *
  * Bonding port must be stopped to change this configuration.
  *
- * @see rte_eth_bond_8023ad_slow_pkt_hw_filter_enable
+ * @see
+ *   rte_eth_bond_8023ad_slow_pkt_hw_filter_enable
  *
- * @param port_id      Bonding device id
+ * @param port_id
+ *   Bonding device id
  * @return
  *   0 on success, negative value otherwise.
  *
@@ -309,9 +331,11 @@ rte_eth_bond_8023ad_dedicated_queues_enable(uint16_t port_id);
 int
 rte_eth_bond_8023ad_dedicated_queues_disable(uint16_t port_id);
 
-/*
+/**
  * Get aggregator mode for 8023ad
- * @param port_id Bonding device id
+ *
+ * @param port_id
+ *   Bonding device id
  *
  * @return
  *   aggregator mode on success, negative value otherwise
@@ -321,7 +345,9 @@ rte_eth_bond_8023ad_agg_selection_get(uint16_t port_id);
 
 /**
  * Set aggregator mode for 8023ad
- * @param port_id Bonding device id
+ * @param port_id
+ *   Bonding device id
+ *
  * @return
  *   0 on success, negative value otherwise
  */
diff --git a/drivers/net/bonding/rte_eth_bond_alb.h b/drivers/net/bonding/rte_eth_bond_alb.h
index f51c355d36..3cf0d87750 100644
--- a/drivers/net/bonding/rte_eth_bond_alb.h
+++ b/drivers/net/bonding/rte_eth_bond_alb.h
@@ -63,9 +63,12 @@ bond_mode_alb_enable(struct rte_eth_dev *bond_dev);
  * forwarded to application without changes. If it is ARP reply, client table
  * is updated.
  *
- * @param eth_h			ETH header of received packet.
- * @param offset		Vlan header offset.
- * @param internals		Bonding data.
+ * @param eth_h
+ *   ETH header of received packet.
+ * @param offset
+ *   Vlan header offset.
+ * @param internals
+ *   Bonding data.
  */
 void
 bond_mode_alb_arp_recv(struct rte_ether_hdr *eth_h, uint16_t offset,
@@ -77,12 +80,15 @@ bond_mode_alb_arp_recv(struct rte_ether_hdr *eth_h, uint16_t offset,
  * If it is ARP Reply, it is send on member stored in client table for that
  * connection. On Reply function also updates data in client table.
  *
- * @param eth_h			ETH header of transmitted packet.
- * @param offset		Vlan header offset.
- * @param internals		Bonding data.
+ * @param eth_h
+ *   ETH header of transmitted packet.
+ * @param offset
+ *   Vlan header offset.
+ * @param internals
+ *   Bonding data.
  *
  * @return
- * Index of member on which packet should be sent.
+ *   Index of member on which packet should be sent.
  */
 uint16_t
 bond_mode_alb_arp_xmit(struct rte_ether_hdr *eth_h, uint16_t offset,
@@ -91,12 +97,15 @@ bond_mode_alb_arp_xmit(struct rte_ether_hdr *eth_h, uint16_t offset,
 /**
  * Function fills packet with ARP data from client_info.
  *
- * @param client_info	Data of client to which packet is sent.
- * @param pkt			Pointer to packet which is sent.
- * @param internals		Bonding data.
+ * @param client_info
+ *   Data of client to which packet is sent.
+ * @param pkt
+ *   Pointer to packet which is sent.
+ * @param internals
+ *   Bonding data.
  *
  * @return
- * Index of member on which packet should be sent.
+ *   Index of member on which packet should be sent.
  */
 uint16_t
 bond_mode_alb_arp_upd(struct client_data *client_info,
@@ -105,7 +114,8 @@ bond_mode_alb_arp_upd(struct client_data *client_info,
 /**
  * Function updates member indexes of active connections.
  *
- * @param bond_dev		Pointer to bonding device struct.
+ * @param bond_dev
+ *   Pointer to bonding device struct.
  */
 void
 bond_mode_alb_client_list_upd(struct rte_eth_dev *bond_dev);